<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

     <link href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/5.3.0/css/bootstrap.min.css" rel="stylesheet">
     <link href='https://unpkg.com/boxicons@2.1.4/css/boxicons.min.css' rel='stylesheet'>
     
    </style>     
    <title>Prueba</title>
  </head>
  <style>
    .outer-div {
        height: 100%;
        display: flex;
        flex-direction: column;
    }

    .button-bar {
        margin-bottom: 1rem;
    }

    .grid-wrapper {
        flex: 1 1 auto;
    }
    .example-wrapper {
        display: flex;
        flex-direction: column;
        height: 100%;
    }

    #myGrid {
        flex: 1 1 0px;
        width: 100%;
    }

    .example-header {
        font-family: Verdana, Geneva, Tahoma, sans-serif;
        font-size: 13px;
        margin-bottom: 5px;
    }
  </style>
  <body>
    <nav class="navbar navbar-expand-lg navbar-light bg-light">
        <div class="container-fluid">
            <a class="navbar-brand" href="#">Prueba</a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="collapse navbar-collapse" id="navbarNav">
                <ul class="navbar-nav">
                    <li class="nav-item">
                        <a class="nav-link active" aria-current="page" href="#" id="crearUsuarios">Crear Usuarios</a>
                    </li>
                </ul>
            </div>
        </div>
    </nav>
    <div class="container mt-5">
        <div class="mb-3">
            <label for="Apellido" class="form-label">Buscar</label>
            <input type="text" style="width: 75%;" class="form-control" id="filter-text-box" placeholder="Filter..." oninput="onFilterTextBoxChanged()">
        </div>
        <div id="usuarios" style="width: 75%; height: 350px;" class="ag-theme-alpine">
        </div>
    </div>

<!-- Button trigger modal -->
<button type="button" class="btn btn-primary d-none" data-bs-toggle="modal" data-bs-target="#exampleModal" id="btnModal">
    
</button>
  
  <!-- Modal -->
  <div class="modal fade" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="titleModal"></h5>
          <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
        </div>
        <div class="modal-body">
            <div class="mb-3">
                <label for="Nombre" class="form-label">Nombre*</label>
                <input type="text" class="form-control" id="nombre" aria-describedby="Nombre">
                <input type="text" class="form-control d-none" id="id" >
                <div id="emailHelp" class="form-text">Este Campo es requerido</div>
            </div>
            <div class="mb-3">
                <label for="Apellido" class="form-label">Apellido*</label>
                <input type="text" class="form-control" id="paterno" aria-describedby="Apellido">
                <div id="emailHelp" class="form-text">Este Campo es requerido</div>
                
            </div>
            <div class="mb-3">
                <label for="Edad" class="form-label">Edad*</label>
                <input type="number" class="form-control" id="edad" aria-describedby="Edad">
                <div id="emailHelp" class="form-text">Este Campo es requerido</div>
            </div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancelar</button>
          <button type="button" class="btn btn-primary" id="btnActualizar">Actualizar</button>
        </div>
      </div>
    </div>
  </div>


    
    <script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/5.3.0/js/bootstrap.bundle.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/ag-grid-community@30.2.0/dist/ag-grid-community.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11"></script>

    </script>
    <script>
        var gridOptions; 

        document.addEventListener('DOMContentLoaded',  () => {
            let btnModal = document.querySelector("#btnModal")
            let liveToastBtn = document.querySelector("#liveToastBtn")
            let crearUsuarios = document.querySelector("#crearUsuarios")

            let btnActualizar = document.querySelector("#btnActualizar")
            let id = document.querySelector("#id")
            let nombre = document.querySelector("#nombre")
            let paterno = document.querySelector("#paterno")
            let edad = document.querySelector("#edad")
            let titleModal = document.querySelector("#titleModal")
            

            let columnDefs= [
                { headerName: 'Nombre', field: 'nombre',  minWidth: 250, maxWidth:350 },
                { headerName: 'Apellido', field: 'paterno', minWidth: 250, maxWidth:350},
                { headerName: 'Edad', field: 'edad', minWidth: 100, maxWidth: 100},
                { headerName: 'Acción', cellRenderer: customCellRenderer },
            ]
            
            gridOptions = { 
                defaultColDef: {
                    resizable: true,
                    flex: 1,
                },
                columnDefs: columnDefs 
            }


            let gridDiv = document.querySelector('#usuarios');
            new agGrid.Grid(gridDiv, gridOptions);
            
            mostrarUsuarios() 
            .then(datos => {
                gridOptions.api.setRowData(datos);
            })
            .catch(error => {
                console.log("Error:", error);
            });
        });

        
        function onFilterTextBoxChanged() {
            gridOptions.api.setQuickFilter(
                document.getElementById('filter-text-box').value
            );
        }

        const customCellRenderer = (params) => {
            var btnEditar = document.createElement("button");
            btnEditar.innerHTML = 'Editar';
            btnEditar.classList.add("btn", "btn-primary", "m-1");

            btnEditar.addEventListener('click', () => {
                btnModal.click()
                id.value = params.data.id
                nombre.value = params.data.nombre
                paterno.value = params.data.paterno
                edad.value = params.data.edad
                titleModal.innerHTML  = `Editar ${params.data.nombre} ${params.data.paterno}`
                
            });

            var btnEliminar = document.createElement("button");
            btnEliminar.innerHTML = 'Eliminar';
            btnEliminar.classList.add("btn", "btn-danger", "m-1");

            btnEliminar.addEventListener('click', () => {
                let msg = ''
                let icon = ''
                let formData = new FormData();
                formData.append("opcion", "eliminarUsuario");
                formData.append("id", params.data.id);

                Swal.fire({
                    title: 'Seguro que lo deseas Eliminar?',
                    text: "una ves eliminado no podra ser restaurado!",
                    icon: 'warning',
                    showCancelButton: true,
                    confirmButtonColor: '#0d6efd',
                    cancelButtonColor: '#dc3545',
                    confirmButtonText: 'Si, Eliminalo!',
                    cancelButtonText: 'Cancelar'
                    }).then((result) => {
                    if (result.isConfirmed) {
                        fetchAPI("POST", formData)
                        .then( data => {
                            if(data.status === 200){
                                this.msg = 'Se ingresaron correctamente'
                                this.icon = 'success'
                            }else{
                                this.msg = 'Ooops! error inesperado'
                                this.icon = 'error'
                            }
                        })
                        .catch(e => console.log(e))
                        .finally(() => {
                            Toast.fire({
                                icon: this.icon,
                                title: this.msg
                            })
                            updateTable()
                        });
                    }
                })


            });

            var buttonContainer = document.createElement("div");
            buttonContainer.appendChild(btnEditar);
            buttonContainer.appendChild(btnEliminar);

            return buttonContainer;
        }

        btnActualizar.onclick = () => {
            let formData = new FormData();
            formData.append("opcion", "modificarUsuario");
            formData.append("id", id.value);
            formData.append("nombre", nombre.value);
            formData.append("paterno", paterno.value);
            formData.append("edad", edad.value);
            fetchAPI("POST", formData)
            .then( data => {
                btnModal.click()

                if(data.status === 200){
                    this.msg = 'Se ingresaron correctamente'
                    this.icon = 'success'
                }else{
                    this.msg = 'Ooops! error inesperado'
                    this.icon = 'error'
                }
            })
            .catch(e => console.log(e))
            .finally(() => {
                Toast.fire({
                    icon: this.icon,
                    title: this.msg
                })
                updateTable()
            });
        }
        crearUsuarios.onclick = () => {
            let msg = ''
            let icon = ''
            let formData = new FormData();
            formData.append("opcion", "generarUsuarios");

            Swal.fire({
                title: 'Seguro que deseas agregar mas dato?',
                text: "se aumentaran 10 usuarios!",
                icon: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#0d6efd',
                cancelButtonColor: '#dc3545',
                confirmButtonText: 'Si, Agregalos!',
                cancelButtonText: 'Cancelar'
                }).then((result) => {
                if (result.isConfirmed) {
                    fetchAPI("POST", formData)
                    .then( data => {
                        if(data.status === 200){
                             this.msg = 'Se ingresaron correctamente'
                             this.icon = 'success'
                        }else{
                             this.msg = 'Ooops! error inesperado'
                             this.icon = 'error'
                        }
                    })
                    .catch(e => console.log(e))
                    .finally(() => {
                        Toast.fire({
                            icon: this.icon,
                            title: this.msg
                        })
                        updateTable()
                    });
                }
            })
        }

        const updateTable = () => {
            mostrarUsuarios() 
            .then(datos => {
                gridOptions.api.setRowData(datos);
            })
            .catch(error => {
                console.log("Error:", error);
            });
        }
        const mostrarUsuarios = () => {
            datos = []
            let formData = new FormData();
            formData.append("opcion", "todosUsuarios");

            return fetchAPI("POST", formData)
            .then( data => {
                datos = data.data.data
                return datos
            })
            .catch(e => console.log(e))
            .finally(() => {
                console.log("proceso terminado")
            });

        }

        
        
        const fetchAPI = async(method, data) => {
            let resp = await fetch('../backend/', {
                method: method,
                body: data
            });

            return resp.json();
        }
       
        const Toast = Swal.mixin({
            toast: true,
            position: 'top-end',
            showConfirmButton: false,
            timer: 3000,
            timerProgressBar: true,
            didOpen: (toast) => {
                toast.addEventListener('mouseenter', Swal.stopTimer)
                toast.addEventListener('mouseleave', Swal.resumeTimer)
            }
        })
    </script>
        
  </body>
</html>